//-----------------------------------------------------------------------------+
#property copyright "Copyright  2012, Trishkin Artyom A."
#property link      "support@goldsuccess.ru"
//                   Skype: Artmedia70
//-----------------------------------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>
//==============================================================================
// ---------------------------   ---------------------------+
//==============================================================================
extern string  P_Expert= "-- Experts Variables --";
//-------     ------------------------------+
extern string  P_Performanc= "-- Parameters for Trades --";
//-----------------------------------------------------------------------------+
double         PointX, LotsB, LotsS, Lots_New, MinLot, MaxLot, LotStp,
               Equ_Start, EquPerc, Equ_OLD, Equ_NEW;
string         sy;
int            tf, dg, sp, a,b,c;
double         pt, pa, pb;
//-----------------------------------------------------------------------------+
int            Level_old, 
               Level_new, 
               Magic;
string         New_Comm, Exp_Name, Prefix,
               message1, message2, message3, message4, 
               Mass_Name_Message[10];
bool           FirstStart=true;               
//==============================================================================
//----------------------   --------------------------------+
//==============================================================================
//+----------------------------------------------------------------------------+
int init() {
   MinLot=MarketInfo(Symbol(), MODE_MINLOT);
   MaxLot=MarketInfo(Symbol(), MODE_MAXLOT);
   LotStp=MarketInfo(Symbol(), MODE_LOTSTEP);
   Equ_OLD=AccountEquity();
   Equ_NEW=Equ_OLD;
   if (FirstStart) {
         Equ_Start=Equ_OLD;
         FirstStart=false;
      }
   Level_old=MarketInfo(Symbol(),MODE_STOPLEVEL ); //.   
   if(Digits==5 || Digits==3) PointX = Point * 10; //  Point  - 
   if(Digits==4 || Digits==2) PointX = Point;
   FirstStart=false;
   Exp_Name=WindowExpertName(); 
   Prefix=Exp_Name;  
   Magic=GetMagic(Exp_Name+Symbol(),Period()); 
   return;                                         //   init() 
}
//+----------------------------------------------------------------------------+
int deinit() {
   if (!IsTesting()) Comment("");
// --------    ,    --------
   string Name_Del[1]; 
   int Quant_Del=0;                    
   int Quant_Objects=ObjectsTotal();   
   int LenPref=StringLen(Prefix);
   ArrayResize(Name_Del,Quant_Objects);
   for(int k=0; k<Quant_Objects; k++) {
      string Obj_Name=ObjectName(k);   
      string Head=StringSubstr(Obj_Name,0,LenPref);
      if (Head==Prefix) {                              
         Quant_Del+=1;        
         Name_Del[Quant_Del-1]=Obj_Name;
         }
     }
   for(int i=0; i<Quant_Del; i++)    
      ObjectDelete(Name_Del[i]); 
// -----     ,    -----
   return;                                //   deinit()
}
//+----------------------------------------------------------------------------+
int start() {
   sy=Symbol();
   tf=Period();
   dg=MarketInfo(sy,MODE_DIGITS);
   sp=MarketInfo(sy,MODE_SPREAD);
   pt=MarketInfo(sy,MODE_POINT);
   pa=MarketInfo(sy,MODE_ASK);
   pb=MarketInfo(sy,MODE_BID);
//-----------   ------------   

//-----------   -------------   

//-----------  .  ----------   

//-----------  .  ------------   

//-------------------------------------------------------
   message1=StringConcatenate(": ",GetTickCount()," ");
   message2=StringConcatenate(" Bid: ", DoubleToStr(Bid,dg));
   iPrint(false, message1, message2, "", "", 9, Aqua, DarkOrange);
   b=4; c=7;
   a=b+c;
   message1=StringConcatenate("a=",a," ");
   message2=StringConcatenate("b=",b," ");
   message3=StringConcatenate("c=",c);
   iPrint(false, message1, message2, message3, "", 9, Aqua, LimeGreen, DarkOrange);
   
   message1=StringConcatenate(": ", TimeToStr(TimeCurrent())," ");
   message2=StringConcatenate(": ",GetTickCount()," ");
   message3=StringConcatenate(" : ",TimeToStr(Time[0])," ");
   message4=StringConcatenate(" Bid: ", DoubleToStr(Bid,dg));
   iPrint(false, message1, message2, message3, message4, 9, Aqua, Aqua, Aqua, DarkOrange);
   return;                                //   start()
}
//+----------------------------------------------------------------------------+
void iPrint(bool print, string mess1, string mess2="", string mess3="", string mess4="", 
            int sz=9, color cl1=Aqua, color cl2=Aqua, color cl3=Aqua, color cl4=Aqua) {
   string   NameGrafText, message, nm;
   int      i, y, k, LenStr, shift, Win_Num=-1, num=0;
   color    cl;
   if (mess1=="") {
      Print("Func iPrint:   , ");
      return;
      }
   Win_Num=WindowFind("Win_Inform");
   if (print || Win_Num<0) {
      message=mess1+mess2+mess3+mess4;
      Print(message); 
      return;
      }
   k=ArraySize(Mass_Name_Message)-1;
   if (StringLen(mess1)>0) num++;
   if (StringLen(mess2)>0) num++;
   if (StringLen(mess3)>0) num++;
   if (StringLen(mess4)>0) num++;
   for (i=k; i>=0; i--) {                             
      NameGrafText=Mass_Name_Message[i];           
      if (StringLen(NameGrafText)>0)
      if (ObjectFind(NameGrafText)==Win_Num) {
         if (i+num>k) {
            ObjectDelete(NameGrafText);  
            Mass_Name_Message[i]="";
            }
         else if (i+num<=k) {
            Mass_Name_Message[i+num]=Mass_Name_Message[i];
            y=ObjectGet(NameGrafText, OBJPROP_YDISTANCE);               //  Y
            ObjectSet  (NameGrafText, OBJPROP_YDISTANCE, y+(sz+1)*num); //  Y
            ObjectSet  (NameGrafText, OBJPROP_COLOR, LightSeaGreen);    // 
            }
         }
      }
   shift=num;
   int v=GetTickCount();
   for (i=0; i<num; i++) {
      shift--;
      NameGrafText=Prefix+"_Graf_Text_"+i+"_"+sy+"_"+v;
      int app=0;
      while (ObjectFind(NameGrafText)==Win_Num) {
         app++;
         NameGrafText=Prefix+"_Graf_Text_"+i+"_"+sy+"_"+v+"_"+app;
         }
      Mass_Name_Message[num-1-i]=NameGrafText;
      switch (i) {
         case 0: message=mess1; cl=cl1; break;
         case 1: message=mess2; cl=cl2; break;
         case 2: message=mess3; cl=cl3; break;
         case 3: message=mess4; cl=cl4; break;
         default:message=mess1; cl=cl1; break;
         }
      ObjectCreate (NameGrafText, OBJ_LABEL, Win_Num, 0, 0);
      ObjectSetText(NameGrafText, message, sz, "Courier New", cl);
      ObjectSet    (NameGrafText, OBJPROP_COLOR, cl);                   // 
      ObjectSet    (NameGrafText, OBJPROP_CORNER,    2);                // 
      ObjectSet    (NameGrafText, OBJPROP_XDISTANCE, 150);              //  
      ObjectSet    (NameGrafText, OBJPROP_YDISTANCE, 2+(sz+1)*shift);   //  Y
      WindowRedraw();
      }
//---------------------------------      
   nm=Prefix+"_Balance_txt";
   message=" :";
   cl=Yellow;
   SetText(message, cl, nm, 2, 4, 20, "Arial", 9, Win_Num);
   nm=Prefix+"_Balance";
   message=DoubleToStr(AccountBalance(),2);
   cl=DarkTurquoise;
   SetText(message, cl, nm, 2, 70, 20, "Arial", 9, Win_Num);
//---------------------------------      
   nm=Prefix+"_Equity_txt";
   message=" :";
   cl=Yellow;
   SetText(message, cl, nm, 2, 4, 8, "Arial", 9, Win_Num);
   nm=Prefix+"_Equity";
   message=DoubleToStr(AccountEquity(),2);
   cl=DarkTurquoise;
   SetText(message, cl, nm, 2, 70, 8, "Arial", 9, Win_Num);
//---------------------------------      
}
//+----------------------------------------------------------------------------+
void SetText(string Text, color cl, string nm, int angle, int x, int y, string font, int sz=0, int wnd=0) {
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, wnd, 0, 0);
   ObjectSet(nm, OBJPROP_CORNER   , angle);
   ObjectSet(nm, OBJPROP_XDISTANCE, x);
   ObjectSet(nm, OBJPROP_YDISTANCE, y);
   ObjectSet(nm, OBJPROP_WIDTH    , sz);
   ObjectSetText(nm, Text, sz, font, cl);
   }
//+----------------------------------------------------------------------------+
int GetMagic(string symbolstring, int multiplier){
   int res=0;
   int len=StringLen(symbolstring);
   for(int i=0; i<len; i++)
       res+=StringGetChar(symbolstring,i);      
   return(res*multiplier);
}
//+----------------------------------------------------------------------------+

